| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | List of all members
cv::ccalib::CustomPattern Class Reference
Custom Calibration Pattern for 3D reconstruction

`#include <opencv2/ccalib.hpp>`

Inheritance diagram for cv::ccalib::CustomPattern:

## Public Member Functions
| CustomPattern ()
virtual | ~CustomPattern ()
double | calibrate (InputArrayOfArrays objectPoints, InputArrayOfArrays imagePoints, Size imageSize, InputOutputArray cameraMatrix, InputOutputArray distCoeffs, OutputArrayOfArrays rvecs, OutputArrayOfArrays tvecs, int flags=0, TermCriteria criteria=TermCriteria(TermCriteria::COUNT+TermCriteria::EPS, 30, DBL_EPSILON))
bool | create (InputArray pattern, const Size2f boardSize, OutputArray output=noArray())
void | drawOrientation (InputOutputArray image, InputArray tvec, InputArray rvec, InputArray cameraMatrix, InputArray distCoeffs, double axis_length=3, int axis_width=2)
bool | findPattern (InputArray image, OutputArray matched_features, OutputArray pattern_points, const double ratio=0.7, const double proj_error=8.0, const bool refine_position=false, OutputArray out=noArray(), OutputArray H=noArray(), OutputArray pattern_corners=noArray())
bool | findRt (InputArray objectPoints, InputArray imagePoints, InputArray cameraMatrix, InputArray distCoeffs, InputOutputArray rvec, InputOutputArray tvec, bool useExtrinsicGuess=false, int flags=SOLVEPNP_ITERATIVE)
bool | findRt (InputArray image, InputArray cameraMatrix, InputArray distCoeffs, InputOutputArray rvec, InputOutputArray tvec, bool useExtrinsicGuess=false, int flags=SOLVEPNP_ITERATIVE)
bool | findRtRANSAC (InputArray objectPoints, InputArray imagePoints, InputArray cameraMatrix, InputArray distCoeffs, InputOutputArray rvec, InputOutputArray tvec, bool useExtrinsicGuess=false, int iterationsCount=100, float reprojectionError=8.0, int minInliersCount=100, OutputArray inliers=noArray(), int flags=SOLVEPNP_ITERATIVE)
bool | findRtRANSAC (InputArray image, InputArray cameraMatrix, InputArray distCoeffs, InputOutputArray rvec, InputOutputArray tvec, bool useExtrinsicGuess=false, int iterationsCount=100, float reprojectionError=8.0, int minInliersCount=100, OutputArray inliers=noArray(), int flags=SOLVEPNP_ITERATIVE)
Ptr< DescriptorExtractor > | getDescriptorExtractor ()
Ptr< DescriptorMatcher > | getDescriptorMatcher ()
Ptr< FeatureDetector > | getFeatureDetector ()
void | getPatternPoints (std::vector< KeyPoint > &original_points)
double | getPixelSize ()
bool | isInitialized ()
bool | setDescriptorExtractor (Ptr< DescriptorExtractor > extractor)
bool | setDescriptorMatcher (Ptr< DescriptorMatcher > matcher)
bool | setFeatureDetector (Ptr< FeatureDetector > featureDetector)
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Constructor & Destructor Documentation

## ◆ CustomPattern()

cv::ccalib::CustomPattern::CustomPattern | ( |  | ) |

## ◆ ~CustomPattern()

virtual cv::ccalib::CustomPattern::~CustomPattern | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ calibrate()

double cv::ccalib::CustomPattern::calibrate | ( | InputArrayOfArrays | objectPoints,
|  | InputArrayOfArrays | imagePoints,
|  | Size | imageSize,
|  | InputOutputArray | cameraMatrix,
|  | InputOutputArray | distCoeffs,
|  | OutputArrayOfArrays | rvecs,
|  | OutputArrayOfArrays | tvecs,
|  | int | flags = `0`,
|  | TermCriteria | criteria = `TermCriteria(TermCriteria::COUNT+TermCriteria::EPS, 30, DBL_EPSILON)`
| ) |  |

Calls the calirateCamera function with the same inputs.

## ◆ create()

bool cv::ccalib::CustomPattern::create | ( | InputArray | pattern,
|  | const Size2f | boardSize,
|  | OutputArray | output = `noArray()`
| ) |  |

## ◆ drawOrientation()

void cv::ccalib::CustomPattern::drawOrientation | ( | InputOutputArray | image,
|  | InputArray | tvec,
|  | InputArray | rvec,
|  | InputArray | cameraMatrix,
|  | InputArray | distCoeffs,
|  | double | axis_length = `3`,
|  | int | axis_width = `2`
| ) |  |

pattern_corners -> projected over the image position of the edges of the pattern.

## ◆ findPattern()

bool cv::ccalib::CustomPattern::findPattern | ( | InputArray | image,
|  | OutputArray | matched_features,
|  | OutputArray | pattern_points,
|  | const double | ratio = `0.7`,
|  | const double | proj_error = `8.0`,
|  | const bool | refine_position = `false`,
|  | OutputArray | out = `noArray()`,
|  | OutputArray | H = `noArray()`,
|  | OutputArray | pattern_corners = `noArray()`
| ) |  |

## ◆ findRt() [1/2]

bool cv::ccalib::CustomPattern::findRt | ( | InputArray | objectPoints,
|  | InputArray | imagePoints,
|  | InputArray | cameraMatrix,
|  | InputArray | distCoeffs,
|  | InputOutputArray | rvec,
|  | InputOutputArray | tvec,
|  | bool | useExtrinsicGuess = `false`,
|  | int | flags = `SOLVEPNP_ITERATIVE`
| ) |  |

## ◆ findRt() [2/2]

bool cv::ccalib::CustomPattern::findRt | ( | InputArray | image,
|  | InputArray | cameraMatrix,
|  | InputArray | distCoeffs,
|  | InputOutputArray | rvec,
|  | InputOutputArray | tvec,
|  | bool | useExtrinsicGuess = `false`,
|  | int | flags = `SOLVEPNP_ITERATIVE`
| ) |  |

Uses solvePnP to find the rotation and translation of the pattern with respect to the camera frame.

## ◆ findRtRANSAC() [1/2]

bool cv::ccalib::CustomPattern::findRtRANSAC | ( | InputArray | objectPoints,
|  | InputArray | imagePoints,
|  | InputArray | cameraMatrix,
|  | InputArray | distCoeffs,
|  | InputOutputArray | rvec,
|  | InputOutputArray | tvec,
|  | bool | useExtrinsicGuess = `false`,
|  | int | iterationsCount = `100`,
|  | float | reprojectionError = `8.0`,
|  | int | minInliersCount = `100`,
|  | OutputArray | inliers = `noArray()`,
|  | int | flags = `SOLVEPNP_ITERATIVE`
| ) |  |

## ◆ findRtRANSAC() [2/2]

bool cv::ccalib::CustomPattern::findRtRANSAC | ( | InputArray | image,
|  | InputArray | cameraMatrix,
|  | InputArray | distCoeffs,
|  | InputOutputArray | rvec,
|  | InputOutputArray | tvec,
|  | bool | useExtrinsicGuess = `false`,
|  | int | iterationsCount = `100`,
|  | float | reprojectionError = `8.0`,
|  | int | minInliersCount = `100`,
|  | OutputArray | inliers = `noArray()`,
|  | int | flags = `SOLVEPNP_ITERATIVE`
| ) |  |

Uses solvePnPRansac()

## ◆ getDescriptorExtractor()

Ptr<DescriptorExtractor> cv::ccalib::CustomPattern::getDescriptorExtractor | ( |  | ) |

## ◆ getDescriptorMatcher()

Ptr<DescriptorMatcher> cv::ccalib::CustomPattern::getDescriptorMatcher | ( |  | ) |

## ◆ getFeatureDetector()

Ptr<FeatureDetector> cv::ccalib::CustomPattern::getFeatureDetector | ( |  | ) |

## ◆ getPatternPoints()

void cv::ccalib::CustomPattern::getPatternPoints | ( | std::vector< KeyPoint > & | original_points | ) |

Returns a vector<Point> of the original points.

## ◆ getPixelSize()

double cv::ccalib::CustomPattern::getPixelSize | ( |  | ) |

Get the pixel size of the pattern

## ◆ isInitialized()

bool cv::ccalib::CustomPattern::isInitialized | ( |  | ) |

## ◆ setDescriptorExtractor()

bool cv::ccalib::CustomPattern::setDescriptorExtractor | ( | Ptr< DescriptorExtractor > | extractor | ) |

## ◆ setDescriptorMatcher()

bool cv::ccalib::CustomPattern::setDescriptorMatcher | ( | Ptr< DescriptorMatcher > | matcher | ) |

## ◆ setFeatureDetector()

bool cv::ccalib::CustomPattern::setFeatureDetector | ( | Ptr< FeatureDetector > | featureDetector | ) |

The documentation for this class was generated from the following file:

- opencv2/ccalib.hpp